/**
 * File for struct logic.
 */


// User Import Headers.
#ifndef user_headers
    #define user_headers
    #include "simulate_loads.h"
    #include "structs.h"
#endif


/**
 * Initializes a "thread_struct" object.
 */
thread_struct* initialize_thread_struct(
        int total_processors,
        int seconds_per_index,
        int indexes_per_load,
        int total_loads,
        int thread_num
    ) {

    // Create struct.
    thread_struct* new_struct = calloc(1, sizeof(thread_struct));

    // Populate fields.
    new_struct->total_processors = total_processors;
    new_struct->seconds_per_index = seconds_per_index;
    new_struct->indexes_per_load = indexes_per_load;
    new_struct->total_loads = total_loads;
    new_struct->thread_num = thread_num;

    return new_struct;
}


/**
 * Destroyes passed "thread_struct" object and all associated fields.
 */
void free_thread_struct(thread_struct* a_struct) {
    free(a_struct);
}
